<template>
  <Transition
    appear
    mode="out-in"
    name="fade"
  >
    <DropTaskWrapper
      v-if="!dragging"
      ref="dragTarget"
      class="flex min-h-[26px] w-full flex-col gap-3 rounded transition-all"
      @drop="moveTask"
    >
      <template #default>
        <form
          class="group/drag-button group/task relative flex flex-nowrap gap-3"
        >
          <DragButton
            ref="dragHandle"
            class="absolute -left-6 h-6 w-5 opacity-0 group-hover/task:opacity-100"
          />
          <Checkbox
            :id="checkboxId"
            v-model="done"
            class="peer"
          />
          <TextField
            :id="textFieldId"
            ref="focusTarget"
            v-model="title"
            class="shrink grow text-base text-slate-600 peer-checked:pointer-events-none peer-checked:opacity-30"
            @keydown="tryRemoveOrCreateTask"
            @blur="tryRemoveTaskIfValueEmpty"
          />
        </form>
      </template>
      <template #children>
        <TaskChildren
          class="mb-4 gap-4 pl-4"
          :parent="task"
        />
      </template>
    </DropTaskWrapper>
    <section
      v-else
      class="flex min-h-[26px] w-full flex-col gap-3 rounded bg-slate-50 transition-all"
    />
  </Transition>
</template>

<script lang="ts" setup>
import {
  type ITask,
  useTaskFocus,
  useTryRemoveEmptyTask,
  useTaskDraggable,
  DropTaskWrapper,
  DropTaskEvent,
} from '~entities/tasks';
import { useTasksStore } from '~/stores/tasks';
import { TextField, Checkbox, DragButton } from '~shared/ui';
import { TaskChildren } from '~features/tasks';

const props = defineProps<{
  task: ITask;
}>();
const { id, done, title, parent, order } = toRefs(props.task);
const textFieldId = `task-text-field-${id.value}`;
const checkboxId = `task-checkbox-${id.value}`;
const { tryRemoveTaskIfValueEmpty } = useTryRemoveEmptyTask(id);
const store = useTasksStore();
const focusTarget = ref();
useTaskFocus(id, focusTarget);

watch([done, title], ([done, title]) => {
  store.updateTask({ ...props.task, title, done });
});

const tryRemoveOrCreateTask = (e: KeyboardEvent) => {
  if (e.key === 'Backspace') {
    tryRemoveTaskIfValueEmpty(e);
  } else if (e.key === 'Enter') {
    e.preventDefault();
    store.addEmptySiblingTask(parent?.value ?? '', order.value);
  }
};

const { dragHandle, dragTarget, dragging } = useTaskDraggable(id);

const moveTask = ({ type, taskId }: DropTaskEvent) => {
  if (type === 'inside') {
    store.moveTask(taskId, id?.value);
  } else if (type === 'before') {
    store.moveTask(taskId, parent?.value, order.value - 0.5);
  } else if (type === 'after') {
    store.moveTask(taskId, parent?.value, order.value + 0.5);
  }
};
</script>
